package fr.mrdev023.vulkan_java.vk;

import fr.mrdev023.vulkan_java.window.Display;

import java.util.Optional;

import static org.lwjgl.glfw.GLFWVulkan.glfwVulkanSupported;

public class Vulkan {

    private static Instance instance;
    private static PhysicalDevice physicalDevice;
    private static Device device;
    private static Surface surface;
    private static Queue.GraphicsQueue graphicsQueue;

    public static void init() throws VulkanError {
        if (!glfwVulkanSupported()) {
            throw new IllegalStateException("Cannot find a compatible Vulkan installable client driver (ICD)");
        }

        instance = new Instance(true);
        physicalDevice = PhysicalDevice.createPhysicalDevice(instance, Optional.empty());
        device = new Device(physicalDevice);
        surface = new Surface(physicalDevice, Display.getWindow());
        graphicsQueue = new Queue.GraphicsQueue(device, 0);
    }

    public static void destroy() {
        surface.destroy();
        device.destroy();
        physicalDevice.destroy();
        instance.destroy();
    }

}
